// Wormhout7.pde
// OuvertureXml.pde
// 
// Gerard Paresys Guy Kayser
// 18 12 2014
// Processing 2.0.3
//
// A partir de http://www.openprocessing.org/sketch/77718
// "Worm" de Adam Lastowka
// "A worm, building a landscape by "tunneling" all over it, raising and lowering the terrain.
// Somewhat like the sandworms in "Dune" by Frank Herbert,
// except for the rainbows and strange fading trails."
// en remplacant Maker[] Worm = new Maker[1];
// par             Maker Worm = new Maker(); (1 seul worm)
//
// Utilise la library minim incluse dans Processing 2
// http://code.compartmental.net/minim/
//
// Utilise la "contributed library" peasycam by Jonathan Feinberg
// http://mrfeinberg.com/peasycam/
//
// PeasyCam: Souris Molette           : Zoom
//           Souris Clic droit + Drag : Zoom      
//           Souris Clic + Drag       : Rotation      
//           Souris 2 x Clic          : Reset position
//           Souris cmd + Clic + Drag : Translate (MacOS)
// Touche Clavier:
//  E Erosion Lissage
//  R Reset
//  C Couleur Worm
//  S Sauve l'ecran (format png)
//  L Lumiere
//
// Si le dossier data contient 5 fichiers nommés:
//   XXX.xml  (format Praat TextGrid sauve en UTF8)
//   XXX.mp3
//   XXX_Pitch.txt
//   XXX_Intensity.txt
//   XXX.png
// le sketch les ouvre
// sinon un selecteur de fichiers s'ouvre, choisir alors un fichier XXX.xml...
//
// Modifier la ligne 50 au besoin
//
// Le dossier data doit contenir aussi:
//   Reunion256x256.png
//

import ddf.minim.*;         // pour AudioPlayer
import peasy.*;

String  NomFichierXML = "reunionn.xml"; // les 5 fichiers "reunion..." doivent etre dans le dossier data
// String  NomFichier = "Reunion256x256.png"; 
// String  NomFichier = "Gris256x256.png"; 
String  NomFichier = "occitan.png"; 

boolean Lumiere    = true;
boolean AfficheT   = true;        // Chrono
Boolean Couleur    = false;
boolean Verbose    = false;

XML[] Traduction, Transcription;
int NombreSegment;
String[] LignesPitch;
String[] LignesIntensity;
float[] LignePitch, LigneIntensity;
boolean FichierOuvert = false;

Minim minim;
AudioPlayer player;

PeasyCam pcam;

float[][] hm  = new float[256][256]; // hm[x][y] = brightness(Image)
float[][] hm2 = new float[256][256];
int hmlengthdemi = hm.length / 2;

float  M = 2;          // M = diametre du worm

boolean Pause = false;
float Temps, TempsPause = 0, TempsDebutPause = 0;
PFont  maFonte;


Maker Worm = new Maker(); 
float wormTemp;
int   x, y, Alea;
float Distance;

PImage Image1;
color MonPixel;

int IndexXML = 0, Segment;
float xmin, xmax;  // Temps en seconde
String Content1 = "", Content2 = "", Content = "";
float Intensite;
float  Facteur;


void setup() {  
  // size(800, 600, P3D);
  size(800, 600, OPENGL);
  // size(400, 300, P3D);

  Image1 = loadImage(NomFichier);
  // background(Image1);
  image(Image1, 0, 0, width, height);

  pcam = new PeasyCam(this, width/2, height/2, 0, 400); // PeasyCam(PApplet parent, double lookAtX, double lookAtY, double lookAtZ, double distance);
  pcam.setMinimumDistance(50);
  pcam.setMaximumDistance(1000);

  noStroke();
  generateLandscape();

  // colorMode(HSB); // colorMode(RGB);
  // frameRate(2); // A mettre pour mieux comprendre
  maFonte = createFont("AdventPro-Thin", 12);
  // maFonte = createFont("Georgia", 18);

  println("hm.length = " + hm.length);

  File Fichier = new File(dataPath(NomFichierXML));
  if (Fichier.exists()) Ouverture(NomFichierXML);
  else selectInput("select the XML File (format Praat textGrid):", "fileSelected");
  // println("Ouverture de " + NomFichierXML);
}

void draw() {
  background(255, 0, 0);
  // image(Image1, 0, 0);
  // image(Image1, 0, 0, width, height);
  if (Lumiere) lights();



  if (FichierOuvert) {

    if (IndexXML < (NombreSegment-1)) {
      if (Temps > xmax) {                        // Passage au segment suivant
        IndexXML = IndexXML + 1;
        Content = Traduction[IndexXML].getContent();
        Content2 = Transcription[IndexXML].getContent();
        if (Verbose) println();
        if (Verbose) println("IndexXML = " + IndexXML);
        if (Content == null) IndexXML = IndexXML + 1;
        else if (Content.equals("_") == true) IndexXML = IndexXML + 1;//Elimination des caracteres _ qui separe les segments
        // else if ((Temps > xmin) && ! Pause) {
        else if (! Pause) {
          Segment = Traduction[IndexXML].getInt("n"); 
          xmin = Traduction[IndexXML].getFloat("xmin");
          xmax = Traduction[IndexXML].getFloat("xmax");
          Content1 = trim(Content);
          Content2 = trim(Content2);
          println(Content1);
          println(Content2);
        }
      }
    }
    else Pause = true;



    if (Temps < LignesIntensity.length) {
      LigneIntensity = float(split(LignesIntensity[int(Temps * Facteur)], "   "));
      Intensite = LigneIntensity[1];
      Intensite = (Intensite - 40) / 12;
      Intensite = max(Intensite, 0);
      println("Temps = " + Temps + "      Intensite = " + Intensite);
    }


      translate(width/2, height/2);
    if (! Pause) {   
      temGen();
    }
      paintLandscape();
      // Lissage();
      textFont(maFonte, 12); 
      fill(0, 255, 0); // Texte vert
      textAlign(CENTER);
      text(Content1, 0, 170, 60 ); // Traduction

  }
  if (! Pause) {
    Temps = millis() - TempsPause; //temps en ms
    if ( AfficheT ) AfficheTemps(Temps);
    Temps = Temps / 1000; // temps en sec
  }
}

void keyPressed() {
  if      ( key == ' '               ) temGen();  // barre d'espace
  else if ( key == 'e' || key == 'E' ) Lissage(); // Erosion Lissage
  else if ( key == 'r' || key == 'R' ) {
    generateLandscape();
    xmax = 0;
    IndexXML = -1;
    Pause = false;
    TempsPause = millis();
    PlayerAudioDebut();
  }
  else if ( key == 'c' || key == 'C' ) Couleur = !Couleur; // Touche C   Worm rouge
  else if ( key == 's' || key == 'S' ) saveFrame("Screen" + frameCount + ".png");
  else if ( key == 'l' || key == 'L' ) Lumiere = !Lumiere; // Touche L        Lumiere
  else if ( key == 't' || key == 'T' ) AfficheT = !AfficheT;     // Touche T        Affiche Temps en bas a droite
}

void generateLandscape() {
  Image1 = loadImage(NomFichier);
  Image1.loadPixels();
  HeightMap();
  // for (int i = 0; i < 600; i++) temGen();
}

void HeightMap() {
  for ( x = 0; x < hm.length; x++) {
    for ( y = 0; y < hm.length; y++) {
      // hm[x][y] = 0;
      // hm[x][y] = brightness(Image1.pixels[x + (y * hm.length)])/ 255.f;
      // hm[x][y] = brightness(Image1.pixels[x*4 + (y*4*3 * hm.length)])/ 25.f;
      hm[x][y] = brightness(Image1.pixels[x + (y * hm.length)])/ 8.f;
      // println(brightness(Image1.pixels[x*4 + (y*4*3 * hm.length)])/ 25.f);
      // if (x == 128) {
      // println("generateLandscape  hm[128]["  + y + "] = " + hm[128][y] + "  Distance = " + Distance);
      // }
    }
  }
  // for (int i = 0; i < 600; i++) temGen();
}

void temGen() {
  // wormTemp = 0;
  // wormTemp = Worm.wormTheta;
  // Worm.wormTheta = (wormTemp+Worm.wormTheta*2)/3;
  //  Worm.x += sin(Worm.wormTheta)*10;
  //  Worm.y += cos(Worm.wormTheta)*10;
  Worm.x += sin(Worm.wormTheta)*2;
  Worm.y += cos(Worm.wormTheta)*2;
  Worm.wormTheta += Worm.wormThetaDelta;
  Worm.wormThetaDelta += random(-0.1, 0.1);
  // Worm.wormThetaDelta /= 1.05; 
  Worm.wormThetaDelta /= 1.30; // 1.05 le worm tourne beaucoup 1.25 tourne peu  Mettre 1.20
  if      (Worm.x >   hmlengthdemi - 10) Worm.wormTheta = Worm.wormTheta - HALF_PI;
  else if (Worm.x < - hmlengthdemi + 10) Worm.wormTheta = Worm.wormTheta - HALF_PI;
  else if (Worm.y >   hmlengthdemi - 10) Worm.wormTheta = Worm.wormTheta - HALF_PI;
  else if (Worm.y < - hmlengthdemi + 10) Worm.wormTheta = Worm.wormTheta - HALF_PI;

  Alea = int(random(hm.length));

  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      Distance = dist((x-hm.length/2)/M, (y-hm.length/2)/M, Worm.x/M, Worm.y/M);
      // if (Distance != 0) hm[x][y] = hm[x][y] + sin(TWO_PI / (Distance * Distance)) * 4.5 * sin(Worm.wormTheta);
      // if (Distance != 0) hm[x][y] = hm[x][y] + sin(TWO_PI / (Distance * Distance)) * 4.5 * sin(Worm.wormTheta);
      // if (Distance != 0) hm[x][y] = hm[x][y] + (sin(TWO_PI / (Distance * Distance)) + 0) * 4.5 * (sin(Worm.wormTheta) + 0.5); // +1 pour que le worm soit toujours a la surface
      // if (Distance != 0) hm[x][y] = hm[x][y] + (sin(TWO_PI / (Distance * Distance)) + 0) * 4.5 * (sin(Worm.wormTheta) + 0.5); // +1 pour que le worm soit toujours a la surface
      // if ((Distance != 0)  && (Distance < 1)) hm[x][y] = hm[x][y] + (sin(TWO_PI / (Distance * Distance)) + 0) * 4.5 ; 
      // if (Distance != 0) hm[x][y] = hm[x][y] + (sin(TWO_PI / (Distance * Distance)) + 0) * 4.5 ; 
      // if (Distance != 0) hm[x][y] = hm[x][y] + min((1 / (Distance * Distance)), 10) ; 
      // if ((Distance != 0) && (Distance < 1)) hm[x][y] = hm[x][y] + min((1 / (Distance * Distance)), 10) ; 

      //      if ((Distance != 0) && (Distance < 1)) hm[x][y] = hm[x][y] + min((1 / (Distance)), 10) ; // 
      //      else if ((Distance == 0) && (Distance < 1)) hm[x][y] = hm[x][y] + 10 ; // 

      // if (Distance < 1) hm[x][y] = hm[x][y] + 3 ; // 
      // Intensite = -3;
      if (Distance < Intensite) {
        hm[x][y] = hm[x][y] + 3; // 
        // hm[x][y] = brightness(Image1.pixels[x + (y * hm.length)])/ 8.f;
        // Image1.pixels[x + (y * hm.length)] = color(hm[x][y] * 8);
        Image1.pixels[x + (y * hm.length)] = color(hm[x][y] * 8);
      }
      if (Distance < Intensite) hm[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/6;

      // if (Distance < 0.4) Image1.pixels[x + (y * hm.length)] = Image1.pixels[x + (y * hm.length)] + color(100, 0, 0, 150);

      // if ((Distance < 0.2) && Couleur ) Image1.pixels[x + (y * hm.length)] = color(red(Image1.pixels[x + (y * hm.length)])+255, green(Image1.pixels[x + (y * hm.length)])+255, blue(Image1.pixels[x + (y * hm.length)])+255);
      if ((Distance < Intensite / 2) && Couleur ) {
        MonPixel = Image1.pixels[x + (y * hm.length)];
        Image1.pixels[x + (y * hm.length)] = color(red(MonPixel)+255, green(MonPixel), blue(MonPixel));
        hm[x][y] = brightness(Image1.pixels[x + (y * hm.length)])/ 8.f;
      }
      //      if (Distance != 0) {
      //        hm[x][y] = hm[x][y] - min((1 / (Distance)), 15) ; // +1 pour que le worm soit toujours a la surface
      //        if (x > 1)           hm[x-1][y] = hm[x-1][y] - min((0.1 / (Distance)), 15) ; // +1 pour que le worm soit toujours a la surface
      //        if (x < hm.length-1) hm[x+1][y] = hm[x+1][y] - min((0.1 / (Distance)), 15) ; // +1 pour que le worm soit toujours a la surface
      //        if (y > 1)           hm[x][y-1] = hm[x][y-1] - min((0.1 / (Distance)), 15) ; // +1 pour que le worm soit toujours a la surface
      //        if (y < hm.length-1) hm[x][y+1] = hm[x][y+1] - min((0.1 / (Distance)), 15) ; // +1 pour que le worm soit toujours a la surface
      //      }
      // if (x == 128) hm[x][y] = 0; // Creuse ligne verticale
      // if (y == 138) hm[x][y] = max( hm[x][y] - 5, 0); // Creuse ligne horizontale

      //      if (y == Alea-1) hm[x][y] = max( hm[x][y] - 5, 0); // Creuse ligne horizontale
      //      if (y == Alea) hm[x][y] = max( hm[x][y] + 5, 0); // Creuse ligne horizontale
      //      if (y == Alea+1) hm[x][y] = max( hm[x][y] - 5, 0); // Creuse ligne horizontale

      // if (x == 128) println("hm[128]["  + y + "] = " + hm[128][y] + "  Distance = " + Distance);
    }
  }
  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      Distance = dist((x-hm.length/2)/M, (y-hm.length/2)/M, Worm.x/M, Worm.y/M);
      if (Distance < 1) hm[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/6;
    }
  }
  // HeightMap();
  // Image1.updatePixels();
  // Lissage();
}

void paintLandscape() {
  // stroke(128);
  // noStroke();
  // fill(0,0,255); 
  scale(2);
  for ( x = 3; x < hm.length-5; x++) {
    beginShape(QUADS);
    for ( y = 3; y < hm.length-5; y++) {
      // fill(abs(4*hm[x][y]), 255, 255);//origin
      fill(Image1.pixels[x + (y * hm.length)]);
      // beginShape(QUADS);
      vertex(x  -hm.length/2, y  -hm.length/2, hm[x]  [y]);
      vertex(x+1-hm.length/2, y  -hm.length/2, hm[x+1][y]);
      vertex(x+1-hm.length/2, y+1-hm.length/2, hm[x+1][y+1]);
      vertex(x  -hm.length/2, y+1-hm.length/2, hm[x]  [y+1]);
      // endShape(CLOSE);
    }
    endShape(CLOSE);
  }
  scale(0.5);
}


void Lissage() {
  //    for(float x = 1; x < hm.length-1; x++) {
  //        for(float y = 1; y < hm.length-1; y++) {
  //          hm[(int)x][(int)y] = (hm[(int)x][(int)y]*2 + hm[(int)x+1][(int)y] + hm[(int)x-1][(int)y] + hm[(int)x][(int)y+1] + hm[(int)x][(int)y-1])/6;
  //        }
  //    }

  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/6;
    }
  }
  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      hm[x][y] = hm2[x][y];
    }
  }
  println("Lissage");
}


class Maker {
  float x;
  float y;
  float wormTheta;
  float wormThetaDelta;
}

void FinOuverture() {
  minim = new Minim(this);
  player = minim.loadFile(NomFichierAudio, 1024);
  FichierOuvert = true;
  xmax = 0;
  IndexXML = -1;
  Facteur = LignesIntensity.length / LigneIntensity[0]; //Nombre de lignes / Duree totale fichier XXX_Intensity.txt 

  Lissage();
  Lissage();
  player.play();
  TempsPause = millis();
}

void PlayerAudioDebut() {
  player.close();
  player = minim.loadFile(NomFichierAudio, 1024);
  player.play();
  TempsPause = millis();
}

void AfficheTemps(float T) {
  T = int(T / 100);
  T = T / 10;
  // x = width - 72;
  fill(255);
  textFont(maFonte, 12);
  textAlign(LEFT);
  // text(T + " sec   frameRate = "+ (int(10 * frameRate)) / 10.0 + "/sec", width / 2 -100, height * 0.65, 30);
  // text(T + " sec   frameRate = "+ (int(10 * frameRate)) / 10.0 + "/sec", width / 2 -100, height - 250, 30);
  text(T + " sec   frameRate = "+ (int(10 * frameRate)) / 10.0 + "/sec", -200, 150, 60);
}

